# OE: conditional switches
#
#(ie. use with rpm --rebuild):
#
#	--with diet	Compile thttpd against dietlibc

%define build_diet 0

# commandline overrides:
# rpm -ba|--rebuild --with 'xxx'
%{?_with_diet: %{expand: %%define build_diet 1}}

%define	name	thttpd
%define	version	2.20c
%define	release	2mdk

Summary:	Throttleable lightweight httpd server
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	BSD
Group:		System/Servers
URL:		http://www.acme.com/software/thttpd
Source0:	%{name}-%{version}.tar.bz2
Source1:	%{name}.init.bz2
Source2:	%{name}.conf.bz2
Source3:	index.html.bz2
Patch0:		%{name}-%{version}-kernel2.4.patch.bz2
Patch1:		%{name}-%{version}-mkstemp.patch.bz2
PreReq:		rpm-helper
Provides:	webserver
BuildRoot:	%{_tmppath}/%{name}-buildroot

%if %{build_diet}
BuildRequires: /usr/bin/diet
BuildRequires: dietlibc-devel >= 0.20-1mdk
%endif

%description
Thttpd is a very compact no-frills httpd serving daemon that can
handle very high loads.  While lacking many of the advanced
features of Apachee, thttpd operates without forking and is
extremely efficient in memory use.  Basic support for cgi scripts,
authentication, and ssi is provided for. Advanced features include
the ability to throttle traffic.

%prep

%setup -q
%patch0 -p0
%patch1 -p1

%build

%if %{build_diet}
export CC="diet gcc"
export CCOPT="-Os -static -nostdinc -D_BSD_SOURCE"
export CFLAGS="-Os -static -nostdinc -D_BSD_SOURCE"
%configure
%else
%configure
%endif

%make \
    prefix=%{_prefix} \
    BINDIR=%{_sbindir} \
    MANDIR=%{_mandir} \
    WEBDIR=/var/%{name} \
    WEBGROUP=%{name} \
    CGIBINDIR=/var/%{name}/cgi-bin

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_initrddir}
install -d %{buildroot}/var/%{name}/cgi-bin
install -d %{buildroot}/var/log/%{name}
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_mandir}/man{1,8}

install -m755 %{name} %{buildroot}%{_sbindir}/%{name}
install -m755 extras/htpasswd %{buildroot}%{_sbindir}/%{name}-htpasswd
install -m755 extras/makeweb %{buildroot}%{_sbindir}/
install -m755 extras/syslogtocern %{buildroot}%{_sbindir}/
install -m644 extras/htpasswd.1 %{buildroot}%{_mandir}/man1/%{name}-htpasswd.1
install -m644 extras/makeweb.1 %{buildroot}%{_mandir}/man1/
install -m644 extras/syslogtocern.8 %{buildroot}%{_mandir}/man8/
install -m644 thttpd.8 %{buildroot}%{_mandir}/man8/

install -m755 cgi-bin/printenv %{buildroot}/var/%{name}/cgi-bin/printenv.cgi
install -m755 cgi-src/phf %{buildroot}/var/%{name}/cgi-bin/
install -m755 cgi-src/redirect %{buildroot}/var/%{name}/cgi-bin/
install -m755 cgi-src/ssi %{buildroot}/var/%{name}/cgi-bin/
install -m644 cgi-src/redirect.8 %{buildroot}%{_mandir}/man8/
install -m644 cgi-src/ssi.8 %{buildroot}%{_mandir}/man8/

bzcat %{SOURCE1} > %{buildroot}%{_initrddir}/%{name}
bzcat %{SOURCE2} > %{buildroot}%{_sysconfdir}/%{name}.conf
chmod 755 %{buildroot}%{_initrddir}/%{name}
chmod 644 %{buildroot}%{_sysconfdir}/%{name}.conf

bzcat %{SOURCE3} > %{buildroot}/var/%{name}/index.html
chmod 644 %{buildroot}/var/%{name}/index.html

%clean
rm -rf %{buildroot}

%post
%_post_service %{name}

%preun
%_preun_service %{name}

%pre 
%_pre_useradd %{name} /var/%{name} /bin/sh

%postun
%_postun_userdel %{name}

%files
%defattr(-,root,root)
%doc README TODO
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_initrddir}/%{name}
%attr(2755,%{name},%{name}) %{_sbindir}/makeweb
%attr(0755,root,root) %{_sbindir}/%{name}-htpasswd
%attr(0755,root,root) %{_sbindir}/syslogtocern
%attr(0755,root,root) %{_sbindir}/%{name}
%attr(0755,%{name},%{name}) %dir /var/%{name}
%attr(0644,%{name},%{name}) /var/%{name}/index.html
%attr(0755,%{name},%{name}) %dir /var/%{name}/cgi-bin
%attr(0755,%{name},%{name}) %dir /var/log/%{name}
%attr(0755,%{name},%{name}) /var/%{name}/cgi-bin/printenv.cgi
%attr(0755,%{name},%{name}) /var/%{name}/cgi-bin/phf
%attr(0755,%{name},%{name}) /var/%{name}/cgi-bin/redirect
%attr(0755,%{name},%{name}) /var/%{name}/cgi-bin/ssi
%{_mandir}/man*/*

%changelog
* Thu Jan 16 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.20c-2mdk
- build release

* Wed Oct 30 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.20c-1mdk
- use spec file magic to enable compilation against dietlibc, use
  "rpm --rebuild --with diet thttpd-2.20c-1mdk.src.rpm"
- added S1, S2 & S3
- added P1 from 2.23beta1
- initial cooker contrib (ripped from RH, adapted for ML)


